Package oracle.jdbc

## Interface OracleShardingKeyBuilder

All Superinterfaces:
  `java.sql.ShardingKeyBuilder`

All Known Implementing Classes:
  `OracleShardingKeyBuilderImpl`

    public interface OracleShardingKeyBuilder
    extends java.sql.ShardingKeyBuilder

A builder created from a `OracleDataSource` or `OracleXADataSource` or `OracleConnectionPoolDataSource` object, used to create a `OracleShardingKey` with sub-keys of supported data types.

The following example illustrates the use of `OracleShardingKeyBuilder` to create a `OracleShardingKey`:

        OracleDataSource ods = new oracle.jdbc.pool.OracleDataSource();

        OracleShardingKey shardingKey =
            ods.createShardingKeyBuilder()
               .subkey("Customer_Name_XYZ", JDBCType.VARCHAR)
               .subkey(94002, JDBCType.NUMERIC)
               .build();

Since:
  12.2

### Method Summary

All Methods Instance Methods Abstract Methods
`OracleShardingKey` `build()` Builds the Sharding key.
`OracleShardingKeyBuilder` `subkey​(java.lang.Object key, java.sql.SQLType subkeyType)` This method is called to include a subkey into a sharding Key object being built.

### Method Detail

#### subkey

    OracleShardingKeyBuilder subkey​(java.lang.Object key,
                                    java.sql.SQLType subkeyType)

This method is called to include a subkey into a sharding Key object being built. The order in which subkey method is called is important as it indicates the order of placement of the subkey within the sharding key.

Specified by:
  `subkey` in interface `java.sql.ShardingKeyBuilder`
Parameters:
  `key` - contains the sharding sub-key object.
  `subkeyType` - sharding sub-key data type.
Returns:
  this `OracleShardingKeyBuilder` object

#### build

    OracleShardingKey build()
                     throws java.sql.SQLException

Builds the Sharding key.

Specified by:
  `build` in interface `java.sql.ShardingKeyBuilder`
Returns:
  new `OracleShardingKey` object that is built.
Throws:
  `java.sql.SQLException` - if there is an error while building the Sharding key.